#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <string.h>
#include <time.h>
#include <sys/errno.h>
#include <sys/param.h>
#include <sys/time.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/time.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <pwd.h>

/*
** my #defines
*/
#define SENDMAIL "/usr/lib/sendmail -fphaser560"
#define PADMIN "wcolburn@nmt.edu"
#define CHUNK (1024 * 64)
#define ACCTDIR "/fs/lprng/"
#define ACCTFILE "acct.log"

/*
** #defines from LPRng errorcodes.h
*/
#define JSUCC    0     /* done */
/* from 1 - 31 are signal terminations */
#define JFAIL    32    /* failed - retry later */
#define JABORT   33    /* aborted - do not try again, but keep job */
#define JREMOVE  34    /* failed - remove job */
#define JACTIVE  35    /* active server - try later */
#define JIGNORE  36    /* ignore this job - not used! */
#define JHOLD    37    /* hold this job */
#define JNOSPOOL 38    /* no spooling to this queue */
#define JNOPRINT 39    /* no printing from this queue  */
#define JSIGNAL  40    /* killed by unrecognized signal */
#define JFAILNORETRY  41 /* no retry on failure */

/*
** headers to make -Wall shut up
*/
void *malloc(size_t size);
void free(void *ptr);
void *realloc(void *ptr, size_t size);
unsigned long int inet_addr(const char *cp);

typedef enum { e_err=(-1), e_ok=0} err_t;
typedef enum { true=1, false=0} bool_t;

typedef struct
{
  char *buf;
  size_t len;
} buf_t;

typedef enum
{
  FERROR=(-1),
  FUNKNOWN=0,
  FTEXT,
  FPOSTSCRIPT,
  FROFF,
  FDVI,
  FJPEG,
  FTIFF,
  FGIF,
  FPJL,
} filetype_t;


typedef struct
{
  char *printername; /* -P */
  char *username;    /* -n */
  char *jobname;     /* -J */
  char *jobnumber;   /* -j */
  char *hostname;    /* -h */
  char *zopts;       /* -Z */
  char *datapath;    /* -e */
  bool_t banner;     /* --banner */
  char *realname;    /* synthetic */
  char *comment;     /* -S */
  char *queuename;   /* -Q */
}
options_t;

char *now(void);
struct timeval timemax(struct timeval t1, struct timeval t2);
struct timeval timemin(struct timeval t1, struct timeval t2);
struct timeval timesum(struct timeval t1, struct timeval t2);
struct timeval timediff(struct timeval t1, struct timeval t2);
struct timeval timediv(struct timeval t, int d);
filetype_t getfiletype(char *filename);
err_t setupfilters(filetype_t filetype);
err_t addfilter(char *filter);
err_t forkfilter(char **argv, char **envp);
void dprintf(char *fmt, ...);
err_t sendemail(char *to, char *subject, ...);
int do_exec(char *path, char **argv, char **envp);
