#include <stdio.h>

/*
** This program converts an HP Printer Job Language file into postscript
*/

/*
** %-12345X@PJL JOB    header (doesn't work with xwp)
** %-12345X@PJL        header
** @                     header continueation
**
** %-12345X@PJL EOJ  end of job
** %-12345X            end of file
*/

/*
** state  description
**   0    first line of header
**   1    skipping @ lines in header
**   2    spewing postscript
**   3    endgame
*/

int main(int argc, char **argv, char **envp)
{
  char *line=NULL;
  int linelen=0;
  int linesize=0;
  int c;
  int state=0;
  char buf[512];

  line=(char *)malloc(512);
  if (line==NULL)
    {
      perror("malloc()");
      exit(1);
    }
  linesize=512;

  while (!feof(stdin))
    {
      /*
      sprintf(buf,"about to read a line of data\n");
      write(fileno(stdout),buf,strlen(buf));
      */

      /*
      ** get a line in an 8 bit clean way
      */
      linelen=0;
      while(!feof(stdin))
	{
	  c=getchar();
	  if (c==EOF) break;
	  line[linelen]=c;
	  linelen++;
	  if (c=='\n') break;
	  if (linelen==linesize)
	    {
	      linesize *= 2;
	      line=(char *)realloc(line,linesize);
	      if (line == NULL)
		{
		  perror("realloc()");
		  exit(1);
		}
	    }
	}
      /* now we have an 8 bit clean line of data */
      /*
      sprintf(buf,"linelen: %d\nstate: %d\n",linelen,state);
      write(fileno(stdout),buf,strlen(buf));
      */
      
      switch(state)
	{
	case 0:
	  /* check for proper first line */
	  if ((linelen >= 17) && (memcmp(line,"\033%-12345X@PJL",13)==0))
	    {
	      state++;
 	    }
	  else
	    {
	      fprintf(stderr,"didn't find PJL header\n");
	      exit(1);
	    }
	  break;
	case 1:
	  /* scan past @ lines */
	  if ((linelen >= 4) && (memcmp(line,"@PJL",4)==0))
	    {
	      /* do nothing */ ;
	    }
	  else
	    {
	      write(fileno(stdout),line,linelen);
	      state++;
	    }
	  break;
	case 2:
	  /* spew postscript */
	  if (line[0] != '\04')
	    {
	      write(fileno(stdout),line,linelen);
	    }
	  else
	    {
	      exit(0); 
	    }
	}
    }
  exit(1);
}
