#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

char *now(void)
{
  time_t ttmp;
  char *stmp;
  static char buf[25];

  time(&ttmp);
  stmp=asctime(localtime(&ttmp));
  stmp[24]='\0';
  strncpy(buf,stmp,24);
  
  return(buf);
}


/*
** greater of t1 or t2
*/
struct timeval timemax(struct timeval t1, struct timeval t2)
{
  if (t1.tv_sec == t2.tv_sec)
    {
      if (t1.tv_usec > t2.tv_usec)
	return (t1);
      else
	return(t2);
    }
    
  if (t1.tv_sec > t2.tv_sec)
    return(t1);
  else
    return(t2);
}

/*
** lesser of t1 or t2
*/
struct timeval timemin(struct timeval t1, struct timeval t2)
{
  if (t1.tv_sec == t2.tv_sec)
    {
      if (t1.tv_usec < t2.tv_usec)
	return (t1);
      else
	return(t2);
    }
    
  if (t1.tv_sec < t2.tv_sec)
    return(t1);
  else
    return(t2);
}

/*
** t1 + t2
*/
struct timeval timesum(struct timeval t1, struct timeval t2)
{
  struct timeval sum={0,0};

  sum.tv_sec=(t1.tv_sec + t2.tv_sec);
  sum.tv_usec=(t1.tv_usec + t2.tv_usec);
  if (sum.tv_usec >= 1000000)
    {
      sum.tv_sec++;
      sum.tv_usec -= 1000000;
    }
  return(sum);
}

/*
** t2 - t1
*/
struct timeval timediff(struct timeval t1, struct timeval t2)
{
  struct timeval diff={0,0};

  diff.tv_sec=(t2.tv_sec-t1.tv_sec);
  
  if (t2.tv_usec > t1.tv_usec)
    {
      diff.tv_usec=t2.tv_usec - t1.tv_usec;
    }
  else
    {
      diff.tv_sec--;
      diff.tv_usec=(1000000 + t2.tv_usec) - t1.tv_usec;
    }

  return(diff);
}

/*
** t / d
*/
struct timeval timediv(struct timeval t, int d)
{
  long rsec;
  struct timeval result={0,0};

  result.tv_sec = t.tv_sec / d;
  rsec = t.tv_sec % d;

  result.tv_usec = (t.tv_usec + (1000000 * rsec)) / d;

  return(result);
}
